#!/usr/bin/perl
###############################################################################
# RW MySQL Dump 1.0.4
###############################################################################
# Copyright (c) 2001-2002 Right Web Developers. All rights reserved.
# http://www.right-web.net/right-dev
# mailto:developers@right-web.net
###############################################################################

########## CONFIGURATION ######################################################
# More information about configure see in readme file
###############################################################################

# BACKUP DIR (required)
# relative or absolute path to backup dir where dumps will be saved 
# (last slash required)
# examples:
$backup_path = "/home/user/mysqlback/";

# DATABASE NAMES (required)
# names of databases to dump in array
# examples:
@databases = ('test');

# MYSQL ACCOUNT (required)
# MySQL Account for DBs access 
# (this user must have read rights on all dumped databases)
$host = "localhost";
$port = "3306";
$user = "test";
$pass = "test";

# LOG FILE LOCATION (optional)
# relative or absolute path to log file (include filename)
# no log output if $logfile is empty or disabled
# examples:
#$logfile = "/home/user/mysqlback/rwmysqldump.log";

# ARCHIVER LOCATION (optional)
# relative or absolute path to archiver (include file name and options)
# dump will be not zipped if $zip is empty or disabled
# DON'T forget to add compress method and other options
# example for Zip util:
# 9 - compress better
# m - move files into arch (delete originals)
# j - junk paths (don't record paths to originals)
# See zip -h for more options
# Also add space to the end of line (next arg will be archive name)
#$zip =  "/usr/bin/zip -9mj ";

# E-MAIL (optional)
# e-mail where log file will be sended
# no e-mail dump if $recipient is empty or disabled
# examples:
#$recipient = 'webmaster@right-web.net';

# SENDMAIL LOCATION (required if E-MAIL option enabled)
# relative or abslute path to sendmail
#$mailprog = '/usr/sbin/sendmail';

########### CODE - Do not edit anything below this line! ######################
use DBI;

$version = "1.0.4";

if($recipient)
{ 
  &mail_open; 
}


&log_output("This is a log of dumping mysql databases produced by 
RW MySQL Dump Version $version\n\n", 1);

("MySQL Dumping started\n");

$fdatezip = &get_filedate;

foreach $database (@databases)
{
  &db_connect($database,$host,$port,$user,$pass);

  $fdate = &get_filedate;
  $path = $backup_path.$database."_".$fdate.".sql";

  if(!open(DUMP, ">$path")) 
  {
    &log_output("Can't create file $path or path not specified");
    &db_disconnect;
    next;
  }
  print DUMP "# Dump of '$database' database created by RW MySQL Dump $version
# at $fdate
# connected as user '$user' to '$host:$port'
#  
# Copyright (c) 2001-2002 RW Developers
# http://www.right-web.net/right-dev
# mailto:developers\@right-web.net\n";

  
  $sql="show tables";
  $table=&db_select($sql);

  &log_output("Dumping DB: $database");

  while($row = $table->fetchrow_arrayref)
  {
	  $table_name=$row->[0];  	
	  &log_output("Dumping structure for table '$table_name'");
  	$str="
#
# Table structure for table '$table_name'
#
CREATE TABLE $table_name (\n";
  
    print DUMP $str;
	
  	$sql_desc="desc $table_name";
  	$result=&db_select($sql_desc);
  	$rows=0;
  	while($myrow = $result->fetchrow_arrayref)
		{
	  	$field=$myrow->[0];
	  	$type=$myrow->[1];
	  	$null=$myrow->[2];
		
	  	$type_for_test = substr($type,0,3);
	  	if (!$null)
			{
		  	$null="NOT NULL";
			}
		  else
		  {
			  $null="";
			}
		
		  $key=$myrow->[3];
		  if ($key eq "PRI")
			{
		  	$primary = "$field";
			}
		  if ($key eq "MUL")
			{
			  $index = "yes";
			}	
		  
      $default=$myrow->[4];
		
		  if (($type_for_test eq "int") && ($null eq "NOT NULL") && (!$default))
			{
			  $default = 0;
			}
		
		  $extra =$myrow->[5];
		  $str="$field $type DEFAULT '$default' $null  $extra,\n";
		  print DUMP $str;
		}
		
		if ($index eq "yes")
		{
		  $sql_index = "show index from $table_name";
		  $result_indx=&db_select($sql_index);
		  $num = 0;
		
      while($myrow = $result_indx->fetchrow_arrayref)
			{
			  $non=$myrow->[1];
			  if ($non eq 1)
				{
			  	$name[$num] = $myrow->[2];
				  $col_name[$num] = $myrow->[4];
				  $num = $num + 1;
				}
			}
		
		  if ($num != 0)
		  {
		    $str = "Key $name[0] (";
			  print DUMP $str;
		    for ($i=0;$i<$num;$i++)
	  		{
		    	if ($i==0)
			  	{
				  	$str = "$col_name[$i]";
					  print DUMP $str;
          }
			    else
				  {
					  $str = ",$col_name[$i]";
					  print DUMP $str;
			    }	
			  }
				$str= ")";
			  print DUMP $str;
			
        if ($primary)
			  {
			    $str = ",
";
  				print DUMP $str;
	  		}
		  	else
			  {
			    $str = "
";
  				print DUMP $str;
			  }
			}
		}	
    
		if ($primary)
		{
		  $str= "Primary key($primary)";
		  print DUMP $str;
    }
		$str= ");

";
	print DUMP $str;
    
  &log_output("Dumping data for table '$table_name'");
	$str="
#
# Dumping data for table '$table_name'	
#
";
	print DUMP $str;

	$sql_select="select * from $table_name";
	$result_select=&db_select($sql_select);
	$tot_fields=$result_select->{NUM_OF_FIELDS};
	$types = $result_select->{type};
	while($myrow = $result_select->fetchrow_arrayref )
	{
		$i = 0;
		$str = "INSERT INTO $table_name VALUES (";
		print DUMP $str;
		while ($i<$tot_fields)
		{
			$type=$types[$i];

			if ($i==0)
			{
				if ($myrow->[$i] || $myrow->[$i]==0)
				{
					$hold=$myrow->[$i];
				}
				else	
				{
					$hold="NULL";
				}
				
				if ($type eq "int" || $hold eq "NULL")
				{
					$str= "$hold";
					print DUMP $str;
				}
				else
				{	
					$hold=~s/'/\\'/g;
					$str= "'$hold'";
					print DUMP $str;
				}	
			}
			else
			{
				if ($myrow->[$i] || $myrow->[$i]==0)
				{
					$hold=$myrow->[$i];
				}
				else	
				{
					$hold="NULL";
				}
				
				if ($type eq "int" || $hold eq "NULL")
				{
					$str= ",$hold";
					print DUMP $str;
				}
				else
				{
					$hold=~s/'/\\'/g;
					$str= ",'$hold'";
					print DUMP $str;
				}
			}
			$i = $i + 1;
		}
		$str= ");\n";
		print DUMP $str;
	}
	$result_select->finish;
}
	
  &log_output("Dump complete for database: '$database' Dumped to '$path'\n");
  
  close(DUMP);

  if(system($zip.$backup_path.$user."_".$fdatezip." ".$path) == 0)
  {
    &log_output("Packed: $path ...OK!");
  }
  else
  {
	  &log_output("Pack of $path ...FAILED!");
  }

  $result->finish;
  $table->finish;  
  &db_disconnect;
}

if($recipient) {&mail_close;}

exit;

######### SUBROUTINES #########################################################
sub get_filedate {
    # Get the current time and format the hour, minutes and seconds.  Add    
    # 1900 to the year to get the full 4 digit year.                         
    ($sec,$min,$hour,$mday,$mon,$year,$wday) = localtime(time);
    $time = sprintf("%02d-%02d-%02d",$hour,$min,$sec);
    $year += 1900;
    $mon++;
    $date_f = sprintf("%02d-%02d-%4d",$mday,$mon,$year);

    # Format the date.             
    
    $date = $date_f."_".$time;
}


sub mail_open{
  $fdate = &get_filedate;
	if(!open(MAIL,"|$mailprog -t")) 
  {
    &log_output("Can't send e-mail");
    $mail_err = 1;
  }
  else
  {
    $mail_err = 0;
    print MAIL "To: $recipient\n";
    print MAIL "From: RW MySQL Dump $version ($user\@rwmysqldump)\n";
    print MAIL "Subject: MySQL Dump from $user ($fdate)\n\n";
  }
}

sub mail_close{
  if($mail_err != 1)
  {
	  close (MAIL);
    &log_output("Log file mailed to $recipient");
  }
}

sub log_output
{
	$date = &get_filedate;
  if($_[1] != 1)
  {	$str = "[$date] ".$_[0]."\n"; }
  else
  {	$str = $_[0]."\n"; }

  if($logfile)
  {
    open (ERR, ">>$logfile");
    print ERR $str;
  	close (ERR);
  }

  print $str;

	if($recipient) {print MAIL $str;}
}

################# Database accessing subroutines ################
sub db_connect
{
	$dbh = DBI->connect("DBI:mysql:$_[0]:$_[1]:$_[2]",$_[3],$_[4],{PrintError => 0});
	if ($DBI::state)
  {
	  &log_output("$DBI::errstr");
    exit; 
  }
}

sub db_disconnect 
{
	$dbh->disconnect;
}

sub db_select 
{
  $sth = $dbh->prepare("$_[0]");
    
  if(!$sth)
  {
    &log_output("$dbh->errstr");
    exit;
  }
   
  if(!$sth->execute())
  {
    &log_output("$DBI::errstr");
    exit;
  }
  return ($sth);
}

sub db_do 
{
  if(!$dbh->do("$_[0]"))
  {
    &log_output("$DBI::errstr");
    exit;
  }
  return 1;
}